// A '.tsx' file enables JSX support in the TypeScript compiler, 
// for more information see the following page on the TypeScript wiki:
// https://github.com/Microsoft/TypeScript/wiki/JSX
/// <amd-dependency path="lib/errorInfoHandler">
"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var React = require('react');
var ReactDom = require('react-dom');
var _ = require('lodash');
var CSSModules = require('react-css-modules');
var SortByColumnsFunctionGenerator = require('./SortByColumnsFunctionGenerator').SortByColumnsFunctionGenerator;
exports.MultiColumnSortableTableRaw = React.createClass({
    _sortingUtility: new SortByColumnsFunctionGenerator(),
    handleSortingEvent: function (columnName) {
        this._sortingUtility.AddSortingColumn(columnName);
        this.forceUpdate();
    },
    render: function () {
        var _this = this;
        var _a = this.props, Data = _a.Data, Fields = _a.Fields, HeaderStyles = _a.HeaderStyles, RowStyles = _a.RowStyles, TableStyle = _a.TableStyle, Styles = _a.Styles;
        var sortingFunc = this._sortingUtility.getSortingFunction();
        if (sortingFunc) {
            Data.sort(sortingFunc);
        }
        return (React.createElement("table", {styleName: "sortable"}, 
            React.createElement("thead", null, 
                React.createElement("tr", null, _.map(Fields, function (Field) {
                    return React.createElement("th", {key: Field.Name, onClick: function () { return _this.handleSortingEvent(Field.Name); }}, 
                        Field.DisplayName === undefined ? Field.Name : Field.DisplayName, 
                        React.createElement("span", {className: Styles[_this._sortingUtility.getSortingIcon(Field.Name)]}));
                }))
            ), 
            React.createElement("tbody", null, _.map(Data, function (Row) {
                return React.createElement("tr", {key: Row.Id}, _.map(Fields, function (Field) {
                    return React.createElement("td", null, Row[Field.Name]);
                }));
            }))));
    }
});
exports.MultiColumnSortableTable = function (props) {
    var Styles = props.Styles;
    var MultiColumnSortableTableWrapped = CSSModules(exports.MultiColumnSortableTableRaw, Styles || { sortable: '' }, { errorWhenNotFound: false });
    return (React.createElement(MultiColumnSortableTableWrapped, __assign({}, props)));
};
//# sourceMappingURL=MultiColumnSortableTable.Component.js.map