"use strict";
var _ = require('lodash');
var firstBy = require('thenby');
var SortByColumnsFunctionGenerator = (function () {
    function SortByColumnsFunctionGenerator() {
        this.SortingColumns = {};
    }
    SortByColumnsFunctionGenerator.prototype.Clear = function () {
        this.SortingColumns = {};
    };
    SortByColumnsFunctionGenerator.prototype.AddSortingColumn = function (columnName) {
        var Column = this.SortingColumns[columnName];
        if (this.SortingColumns[columnName]) {
            if (this.SortingColumns[columnName].Asc)
                this.SortingColumns[columnName].Asc = false;
            else
                delete this.SortingColumns[columnName];
        }
        else {
            this.SortingColumns[columnName] = { Column: columnName, Asc: true };
        }
    };
    SortByColumnsFunctionGenerator.prototype.getSortingFunction = function () {
        var sortingFunction = null;
        _.forEach(this.SortingColumns, function (value, key) {
            if (!sortingFunction) {
                sortingFunction = firstBy(value.Column, value.Asc || -1);
            }
            else {
                sortingFunction = sortingFunction.thenBy(value.Column, value.Asc || -1);
            }
        });
        return sortingFunction;
    };
    SortByColumnsFunctionGenerator.prototype.getSortingIcon = function (columnName) {
        var Column = this.SortingColumns[columnName];
        if (this.SortingColumns[columnName]) {
            if (this.SortingColumns[columnName].Asc)
                return "sort-asc";
            else
                return "sort-desc";
        }
        else {
            return "sort";
        }
    };
    SortByColumnsFunctionGenerator.prototype.getSortingColumns = function () {
        return this.SortingColumns;
    };
    return SortByColumnsFunctionGenerator;
}());
exports.SortByColumnsFunctionGenerator = SortByColumnsFunctionGenerator;
//# sourceMappingURL=SortByColumnsFunctionGenerator.js.map